--
-- Unidad IV
--

use Northwind;

--
-- Funciones de agrupamiento
--

--
-- Funciones de agrupamiento (1)
--

select count(*) from Employees;

--
-- Funciones de agrupamiento (2)
--

select sum(quantity) as 'Cantidad de productos'
from `Order Details`
where OrderID = 10248;

--
-- Funciones de agrupamiento (3)
--

select count(*) as 'Cantidad de jefes'
from Employees
where ReportsTo is null;

--
-- Uso de GROUP BY
--

select ProductID, sum(Quantity) as 'Total'
from `Order Details`
group by ProductID;

--
-- Uso de GROUP BY con HAVING
--

select ProductID, sum(Quantity) as 'Total'
from `Order Details`
group by ProductID
having sum(Quantity) > 300;

--
-- Modificador ROLLUP (1)
--

select ProductID, sum(Quantity) as 'Total'
from `Order Details`
group by ProductID asc
with rollup;

--
-- Modificador ROLLUP (2)
--

select ProductID, OrderID, sum(Quantity) as 'Total'
from `Order Details`
group by ProductID asc, OrderID desc
with rollup;

--
-- Uso de LIMIT
--

select ProductID, sum(Quantity) as 'Total'
from `Order Details`
group by ProductID
order by 2 desc
limit 10;

--
-- Creación de vistas
--

create view V_Orders (ID, Fecha, Cliente, Producto, Precio, Cantidad) 
as 
	select Orders.OrderID, OrderDate, CompanyName, ProductName, `Order Details`.UnitPrice, Quantity
	from Orders join Customers
	on Orders.CustomerID = Customers.CustomerID
	join `Order Details`
	on Orders.OrderID = `Order Details`.OrderID
	join Products
	on `Order Details`.ProductID = Products.ProductID;

select * from V_Orders;

--
-- Modificación de vistas
--

alter view V_Orders (ID, Fecha, Cliente, Producto, Cantidad) as -- se saca el precio
select Orders.OrderID, OrderDate, CompanyName, ProductName, Quantity
from Orders join Customers
on Orders.CustomerID = Customers.CustomerID
join `Order Details`
on Orders.OrderID = `Order Details`.OrderID
join Products
on `Order Details`.ProductID = Products.ProductID;

select * from V_Orders;

--
-- Borrado de vistas
--

drop view V_Orders;

--
-- Información sobre las vistas
--

select * from information_schema.TABLES
where table_name = 'V_Orders';
-- nombre de las vistas


select * from information_schema.VIEWS
where (TABLE_SCHEMA = 'Northwind') and (table_name = 'V_Orders');
-- definición de las vistas
