use Northwind;

drop view VOrdenes;

create view VOrdenes
as
	select Orders.OrderID, Customers.CustomerID, CompanyName as 'Compañía', Employees.EmployeeID, LastName as 'Apellido', FirstName as 'Nombre', OrderDate as 'Fecha'
	from Orders join Customers
	on Orders.CustomerID = Customers.CustomerID
	join Employees
	on Orders.EmployeeID = Employees.EmployeeID;

delimiter //
create procedure Ordenes()
begin
	select * from VOrdenes
    order by fecha;
end //
delimiter ;

call Ordenes();
drop view VDetalleOrden;
create view VDetalleOrden
as
	select Orders.OrderID, Products.ProductID, ProductName as 'Producto', `Order Details`.UnitPrice as 'Precio Unitario', Quantity as 'Cantidad', Discount as 'Descuento', Quantity * (1 - Discount) * `Order Details`.UnitPrice as 'Total'
	from Orders join `Order Details`
    on Orders.OrderID = `Order Details`.OrderID
    join Products
    on Products.ProductID = `Order Details`.ProductID;
    
delimiter //
create procedure DetalleOrden(OrdID int)
begin
	select * from VDetalleOrden
    where OrderID = ordID;
end //
delimiter ;

call DetalleOrden(10248);

delimiter //
create procedure TotalOrden(OrdID int)
begin
	select OrderID, sum(Total) as 'Total'
    from VDetalleOrden
    where OrderID = OrdID
    group by OrderID;
end //
delimiter ;

call TotalOrden(10248);